/* evaluates variables
   Copyright 2002, 2003, 2004, 2005
   Craig Franklin
*/

#pragma once

#include "stdhdr.h"

extern bool eval_enforce_arity(int Arity, int Must_be);
extern bool eval_enforce_simple(const struct pnode *Pnode);
extern int eval_list_length(const struct pnode *List);

extern bool eval_can_evaluate(const struct pnode *Pnode);
extern bool eval_can_evaluate_value(const struct pnode *Pnode);
extern gpasmVal eval_evaluate(const struct pnode *Pnode);
extern gpasmVal eval_maybe_evaluate(const struct pnode *Pnode);

extern int eval_count_reloc(const struct pnode *Pnode);
extern gpasmVal eval_reloc_evaluate(const struct pnode *Pnode, uint16_t Type,
                                    bool *Is_reloc, gpasmVal *Reloc_value, bool Add_coff);

extern int eval_fill_number(const struct pnode *Pnode);

